searchNodes=[{"ref":"RTypes.html","title":"RTypes","type":"module","doc":"The module defines the derive/1 macro which can be used to derive a run-time checker for the given type. The module also defines a function derive/3 which can be used at run time. However, it must be given arguments as module, type name, and a list of type args. Usage Using derive/1 macro iex&gt; require RTypes, as: RTypes iex&gt; is_port_number = RTypes.derive(:inet.port_number()) iex&gt; is_port_number.(8080) true Note that the macro expects the argument as in module.type(arg1, arg2). That is a module name followed by . and the type name, followed by type parameters enclosed in parenthesis. Using derive/3 function iex&gt; is_keyword_list = RTypes.derive(Keyword, :t, [{:type, 0, :pos_integer, []}]) iex&gt; is_keyword_list.(key1: 4, key2: 5) true"},{"ref":"RTypes.html#derive/1","title":"RTypes.derive/1","type":"macro","doc":""},{"ref":"RTypes.html#derive/3","title":"RTypes.derive/3","type":"function","doc":""},{"ref":"RTypes.Checker.html","title":"RTypes.Checker","type":"module","doc":""},{"ref":"RTypes.Checker.html#check!/2","title":"RTypes.Checker.check!/2","type":"function","doc":"Ensure that term corresponds to the given type. The function either returns true or raises an exception explaining what went wrong."},{"ref":"RTypes.Extractor.html","title":"RTypes.Extractor","type":"module","doc":""},{"ref":"RTypes.Extractor.html#extract_type/3","title":"RTypes.Extractor.extract_type/3","type":"function","doc":"Recursively extract and instantiate AST representation of a type. Arguments mod - module type_name - type name type_args - arguments, if any, for the type. The arguments should be represented as AST, for example, {:type, 0, :list, []} Usage iex&gt; extract_type(:inet, :port_number, []) {:type, 102, :range, [{:integer, 102, 0}, {:integer, 102, 65535}]} iex&gt; extract_type(Keyword, :t, [{:type, 0, :list, []}]) {:type, 0, :list, [{:type, 0, :tuple, [{:type, 74, :atom, []}, {:var, 78, :value}]}]}"},{"ref":"RTypes.Extractor.html#t:type/0","title":"RTypes.Extractor.type/0","type":"type","doc":""},{"ref":"RTypes.Extractor.html#t:unfolded_type/0","title":"RTypes.Extractor.unfolded_type/0","type":"type","doc":""},{"ref":"RTypes.Extractor.html#t:value/0","title":"RTypes.Extractor.value/0","type":"type","doc":""},{"ref":"Types.html","title":"Types","type":"module","doc":""},{"ref":"Types.html#t:complex_map/0","title":"Types.complex_map/0","type":"type","doc":""},{"ref":"Types.html#t:type_any/0","title":"Types.type_any/0","type":"type","doc":""},{"ref":"Types.html#t:type_arity/0","title":"Types.type_arity/0","type":"type","doc":""},{"ref":"Types.html#t:type_as_boolean/1","title":"Types.type_as_boolean/1","type":"type","doc":""},{"ref":"Types.html#t:type_atom/0","title":"Types.type_atom/0","type":"type","doc":""},{"ref":"Types.html#t:type_binary/0","title":"Types.type_binary/0","type":"type","doc":""},{"ref":"Types.html#t:type_bitstring/0","title":"Types.type_bitstring/0","type":"type","doc":""},{"ref":"Types.html#t:type_bitstring_empty/0","title":"Types.type_bitstring_empty/0","type":"type","doc":""},{"ref":"Types.html#t:type_bitstring_size/0","title":"Types.type_bitstring_size/0","type":"type","doc":""},{"ref":"Types.html#t:type_bitstring_size_and_units/0","title":"Types.type_bitstring_size_and_units/0","type":"type","doc":""},{"ref":"Types.html#t:type_bitstring_units/0","title":"Types.type_bitstring_units/0","type":"type","doc":""},{"ref":"Types.html#t:type_boolean/0","title":"Types.type_boolean/0","type":"type","doc":""},{"ref":"Types.html#t:type_byte/0","title":"Types.type_byte/0","type":"type","doc":""},{"ref":"Types.html#t:type_char/0","title":"Types.type_char/0","type":"type","doc":""},{"ref":"Types.html#t:type_charlist/0","title":"Types.type_charlist/0","type":"type","doc":""},{"ref":"Types.html#t:type_concrete_tuple/0","title":"Types.type_concrete_tuple/0","type":"type","doc":""},{"ref":"Types.html#t:type_empty_list/0","title":"Types.type_empty_list/0","type":"type","doc":""},{"ref":"Types.html#t:type_empty_map/0","title":"Types.type_empty_map/0","type":"type","doc":""},{"ref":"Types.html#t:type_empty_tuple/0","title":"Types.type_empty_tuple/0","type":"type","doc":""},{"ref":"Types.html#t:type_float/0","title":"Types.type_float/0","type":"type","doc":""},{"ref":"Types.html#t:type_fun/0","title":"Types.type_fun/0","type":"type","doc":""},{"ref":"Types.html#t:type_fun_arity_0/0","title":"Types.type_fun_arity_0/0","type":"type","doc":""},{"ref":"Types.html#t:type_fun_arity_2/0","title":"Types.type_fun_arity_2/0","type":"type","doc":""},{"ref":"Types.html#t:type_fun_arity_any/0","title":"Types.type_fun_arity_any/0","type":"type","doc":""},{"ref":"Types.html#t:type_function/0","title":"Types.type_function/0","type":"type","doc":""},{"ref":"Types.html#t:type_generic/2","title":"Types.type_generic/2","type":"type","doc":""},{"ref":"Types.html#t:type_generic2/1","title":"Types.type_generic2/1","type":"type","doc":""},{"ref":"Types.html#t:type_identifier/0","title":"Types.type_identifier/0","type":"type","doc":""},{"ref":"Types.html#t:type_instansiated/0","title":"Types.type_instansiated/0","type":"type","doc":""},{"ref":"Types.html#t:type_instansiated2/0","title":"Types.type_instansiated2/0","type":"type","doc":""},{"ref":"Types.html#t:type_integer/0","title":"Types.type_integer/0","type":"type","doc":""},{"ref":"Types.html#t:type_iodata/0","title":"Types.type_iodata/0","type":"type","doc":""},{"ref":"Types.html#t:type_iolist/0","title":"Types.type_iolist/0","type":"type","doc":""},{"ref":"Types.html#t:type_keyword/0","title":"Types.type_keyword/0","type":"type","doc":""},{"ref":"Types.html#t:type_keyword/1","title":"Types.type_keyword/1","type":"type","doc":""},{"ref":"Types.html#t:type_kw_list/0","title":"Types.type_kw_list/0","type":"type","doc":""},{"ref":"Types.html#t:type_list/0","title":"Types.type_list/0","type":"type","doc":""},{"ref":"Types.html#t:type_list/1","title":"Types.type_list/1","type":"type","doc":""},{"ref":"Types.html#t:type_literal_atom/0","title":"Types.type_literal_atom/0","type":"type","doc":""},{"ref":"Types.html#t:type_literal_integer/0","title":"Types.type_literal_integer/0","type":"type","doc":""},{"ref":"Types.html#t:type_map/0","title":"Types.type_map/0","type":"type","doc":""},{"ref":"Types.html#t:type_map_keys/0","title":"Types.type_map_keys/0","type":"type","doc":""},{"ref":"Types.html#t:type_map_optional/0","title":"Types.type_map_optional/0","type":"type","doc":""},{"ref":"Types.html#t:type_maybe_improper_list/0","title":"Types.type_maybe_improper_list/0","type":"type","doc":""},{"ref":"Types.html#t:type_maybe_improper_list/2","title":"Types.type_maybe_improper_list/2","type":"type","doc":""},{"ref":"Types.html#t:type_mfa/0","title":"Types.type_mfa/0","type":"type","doc":""},{"ref":"Types.html#t:type_module/0","title":"Types.type_module/0","type":"type","doc":""},{"ref":"Types.html#t:type_neg_integer/0","title":"Types.type_neg_integer/0","type":"type","doc":""},{"ref":"Types.html#t:type_no_return/0","title":"Types.type_no_return/0","type":"type","doc":""},{"ref":"Types.html#t:type_node/0","title":"Types.type_node/0","type":"type","doc":""},{"ref":"Types.html#t:type_non_neg_integer/0","title":"Types.type_non_neg_integer/0","type":"type","doc":""},{"ref":"Types.html#t:type_none/0","title":"Types.type_none/0","type":"type","doc":""},{"ref":"Types.html#t:type_nonempty_charlist/0","title":"Types.type_nonempty_charlist/0","type":"type","doc":""},{"ref":"Types.html#t:type_nonempty_improper_list/2","title":"Types.type_nonempty_improper_list/2","type":"type","doc":""},{"ref":"Types.html#t:type_nonempty_list/0","title":"Types.type_nonempty_list/0","type":"type","doc":""},{"ref":"Types.html#t:type_nonempty_list/1","title":"Types.type_nonempty_list/1","type":"type","doc":""},{"ref":"Types.html#t:type_nonempty_list_short_any/0","title":"Types.type_nonempty_list_short_any/0","type":"type","doc":""},{"ref":"Types.html#t:type_nonempty_list_short_typ/0","title":"Types.type_nonempty_list_short_typ/0","type":"type","doc":""},{"ref":"Types.html#t:type_nonempty_maybe_improper_list/0","title":"Types.type_nonempty_maybe_improper_list/0","type":"type","doc":""},{"ref":"Types.html#t:type_nonempty_maybe_improper_list/2","title":"Types.type_nonempty_maybe_improper_list/2","type":"type","doc":""},{"ref":"Types.html#t:type_number/0","title":"Types.type_number/0","type":"type","doc":""},{"ref":"Types.html#t:type_opaque/0","title":"Types.type_opaque/0","type":"opaque","doc":""},{"ref":"Types.html#t:type_pid/0","title":"Types.type_pid/0","type":"type","doc":""},{"ref":"Types.html#t:type_port/0","title":"Types.type_port/0","type":"type","doc":""},{"ref":"Types.html#t:type_pos_integer/0","title":"Types.type_pos_integer/0","type":"type","doc":""},{"ref":"Types.html#t:type_range/0","title":"Types.type_range/0","type":"type","doc":""},{"ref":"Types.html#t:type_reference/0","title":"Types.type_reference/0","type":"type","doc":""},{"ref":"Types.html#t:type_remote/0","title":"Types.type_remote/0","type":"type","doc":""},{"ref":"Types.html#t:type_remote_generic/1","title":"Types.type_remote_generic/1","type":"type","doc":""},{"ref":"Types.html#t:type_remote_generic/2","title":"Types.type_remote_generic/2","type":"type","doc":""},{"ref":"Types.html#t:type_remote_generic2/2","title":"Types.type_remote_generic2/2","type":"type","doc":""},{"ref":"Types.html#t:type_struct/0","title":"Types.type_struct/0","type":"type","doc":""},{"ref":"Types.html#t:type_term/0","title":"Types.type_term/0","type":"type","doc":""},{"ref":"Types.html#t:type_timeout/0","title":"Types.type_timeout/0","type":"type","doc":""},{"ref":"Types.html#t:type_tuple/0","title":"Types.type_tuple/0","type":"type","doc":""},{"ref":"Types.html#t:type_union/0","title":"Types.type_union/0","type":"type","doc":""},{"ref":"Types2.html","title":"Types2","type":"module","doc":""},{"ref":"Types2.html#t:generic_tuple/2","title":"Types2.generic_tuple/2","type":"type","doc":""},{"ref":"Types2.html#t:remote_type/2","title":"Types2.remote_type/2","type":"type","doc":""},{"ref":"Types3.html","title":"Types3","type":"module","doc":""},{"ref":"Types3.html#t:my_tuple/2","title":"Types3.my_tuple/2","type":"type","doc":""}]